"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SceneTagComponent = exports.SpriteTagComponent = exports.SkinnedMeshTagComponent = exports.PointsTagComponent = exports.MeshTagComponent = exports.LineSegmentsTagComponent = exports.LineLoopTagComponent = exports.LineTagComponent = exports.LODTagComponent = exports.InstancedMeshTagComponent = exports.GroupTagComponent = exports.BoneTagComponent = exports.SpotLightTagComponent = exports.RectAreaLightTagComponent = exports.PointLightTagComponent = exports.LightProbeTagComponent = exports.LightTagComponent = exports.HemisphereLightProbeTagComponent = exports.HemisphereLightTagComponent = exports.DirectionalLightTagComponent = exports.AmbientLightProbeTagComponent = exports.AmbientLightTagComponent = exports.ImmediateRenderObjectTagComponent = exports.PerspectiveCameraTagComponent = exports.OrthographicCameraTagComponent = exports.CubeCameraTagComponent = exports.CameraTagComponent = exports.ArrayCameraTagComponent = exports.PositionalAudioTagComponent = exports.AudioListenerTagComponent = exports.AudioTagComponent = void 0;

var _ecsy = require("ecsy");

// Tag components for every Object3D in the three.js core library
// audio
class AudioTagComponent extends _ecsy.TagComponent {}

exports.AudioTagComponent = AudioTagComponent;

class AudioListenerTagComponent extends _ecsy.TagComponent {}

exports.AudioListenerTagComponent = AudioListenerTagComponent;

class PositionalAudioTagComponent extends _ecsy.TagComponent {} // cameras


exports.PositionalAudioTagComponent = PositionalAudioTagComponent;

class ArrayCameraTagComponent extends _ecsy.TagComponent {}

exports.ArrayCameraTagComponent = ArrayCameraTagComponent;

class CameraTagComponent extends _ecsy.TagComponent {}

exports.CameraTagComponent = CameraTagComponent;

class CubeCameraTagComponent extends _ecsy.TagComponent {}

exports.CubeCameraTagComponent = CubeCameraTagComponent;

class OrthographicCameraTagComponent extends _ecsy.TagComponent {}

exports.OrthographicCameraTagComponent = OrthographicCameraTagComponent;

class PerspectiveCameraTagComponent extends _ecsy.TagComponent {} // extras/objects


exports.PerspectiveCameraTagComponent = PerspectiveCameraTagComponent;

class ImmediateRenderObjectTagComponent extends _ecsy.TagComponent {} // helpers
// Due to inconsistency in implementing consistent identifying properties like "type" on helpers, we've
// chosen to exclude helper tag components.
// lights


exports.ImmediateRenderObjectTagComponent = ImmediateRenderObjectTagComponent;

class AmbientLightTagComponent extends _ecsy.TagComponent {}

exports.AmbientLightTagComponent = AmbientLightTagComponent;

class AmbientLightProbeTagComponent extends _ecsy.TagComponent {}

exports.AmbientLightProbeTagComponent = AmbientLightProbeTagComponent;

class DirectionalLightTagComponent extends _ecsy.TagComponent {}

exports.DirectionalLightTagComponent = DirectionalLightTagComponent;

class HemisphereLightTagComponent extends _ecsy.TagComponent {}

exports.HemisphereLightTagComponent = HemisphereLightTagComponent;

class HemisphereLightProbeTagComponent extends _ecsy.TagComponent {}

exports.HemisphereLightProbeTagComponent = HemisphereLightProbeTagComponent;

class LightTagComponent extends _ecsy.TagComponent {}

exports.LightTagComponent = LightTagComponent;

class LightProbeTagComponent extends _ecsy.TagComponent {}

exports.LightProbeTagComponent = LightProbeTagComponent;

class PointLightTagComponent extends _ecsy.TagComponent {}

exports.PointLightTagComponent = PointLightTagComponent;

class RectAreaLightTagComponent extends _ecsy.TagComponent {}

exports.RectAreaLightTagComponent = RectAreaLightTagComponent;

class SpotLightTagComponent extends _ecsy.TagComponent {} // objects


exports.SpotLightTagComponent = SpotLightTagComponent;

class BoneTagComponent extends _ecsy.TagComponent {}

exports.BoneTagComponent = BoneTagComponent;

class GroupTagComponent extends _ecsy.TagComponent {}

exports.GroupTagComponent = GroupTagComponent;

class InstancedMeshTagComponent extends _ecsy.TagComponent {}

exports.InstancedMeshTagComponent = InstancedMeshTagComponent;

class LODTagComponent extends _ecsy.TagComponent {}

exports.LODTagComponent = LODTagComponent;

class LineTagComponent extends _ecsy.TagComponent {}

exports.LineTagComponent = LineTagComponent;

class LineLoopTagComponent extends _ecsy.TagComponent {}

exports.LineLoopTagComponent = LineLoopTagComponent;

class LineSegmentsTagComponent extends _ecsy.TagComponent {}

exports.LineSegmentsTagComponent = LineSegmentsTagComponent;

class MeshTagComponent extends _ecsy.TagComponent {}

exports.MeshTagComponent = MeshTagComponent;

class PointsTagComponent extends _ecsy.TagComponent {}

exports.PointsTagComponent = PointsTagComponent;

class SkinnedMeshTagComponent extends _ecsy.TagComponent {}

exports.SkinnedMeshTagComponent = SkinnedMeshTagComponent;

class SpriteTagComponent extends _ecsy.TagComponent {} // scenes


exports.SpriteTagComponent = SpriteTagComponent;

class SceneTagComponent extends _ecsy.TagComponent {}

exports.SceneTagComponent = SceneTagComponent;