"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Vector4 = exports.Vector3 = exports.Vector2 = exports.Triangle = exports.SphericalHarmonics3 = exports.Spherical = exports.Sphere = exports.Ray = exports.Quaternion = exports.Plane = exports.Matrix4 = exports.Matrix3 = exports.Line3 = exports.Frustum = exports.Euler = exports.Cylindrical = exports.Color = exports.Box3 = exports.Box2 = void 0;

var _three = require("three");

var _ecsy = require("ecsy");

function defineClonableType(ClassName, ThreeClass) {
  return (0, _ecsy.createType)({
    name: ClassName,
    default: new ThreeClass(),
    copy: _ecsy.copyCopyable,
    clone: _ecsy.cloneClonable
  });
} // Types from the three.js core library
// All types must implement the copy and clone methods.
// Excludes Geometries, Object3Ds, Materials, and other types that require more
// advanced object pooling techniques
// math


const Box2 = defineClonableType("Box2", _three.Box2);
exports.Box2 = Box2;
const Box3 = defineClonableType("Box3", _three.Box3);
exports.Box3 = Box3;
const Color = defineClonableType("Color", _three.Color);
exports.Color = Color;
const Cylindrical = defineClonableType("Cylindrical", _three.Cylindrical);
exports.Cylindrical = Cylindrical;
const Euler = defineClonableType("Euler", _three.Euler);
exports.Euler = Euler;
const Frustum = defineClonableType("Frustum", _three.Frustum);
exports.Frustum = Frustum;
const Line3 = defineClonableType("Line3", _three.Line3);
exports.Line3 = Line3;
const Matrix3 = defineClonableType("Matrix3", _three.Matrix3);
exports.Matrix3 = Matrix3;
const Matrix4 = defineClonableType("Matrix4", _three.Matrix4);
exports.Matrix4 = Matrix4;
const Plane = defineClonableType("Plane", _three.Plane);
exports.Plane = Plane;
const Quaternion = defineClonableType("Quaternion", _three.Quaternion);
exports.Quaternion = Quaternion;
const Ray = defineClonableType("Ray", _three.Ray);
exports.Ray = Ray;
const Sphere = defineClonableType("Sphere", _three.Sphere);
exports.Sphere = Sphere;
const Spherical = defineClonableType("Spherical", _three.Spherical);
exports.Spherical = Spherical;
const SphericalHarmonics3 = defineClonableType("SphericalHarmonics3", _three.SphericalHarmonics3);
exports.SphericalHarmonics3 = SphericalHarmonics3;
const Triangle = defineClonableType("Triangle", _three.Triangle);
exports.Triangle = Triangle;
const Vector2 = defineClonableType("Vector2", _three.Vector2);
exports.Vector2 = Vector2;
const Vector3 = defineClonableType("Vector3", _three.Vector3);
exports.Vector3 = Vector3;
const Vector4 = defineClonableType("Vector4", _three.Vector4);
exports.Vector4 = Vector4;